Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## edu.emory.mathcs.backport.java.util
Class ArrayDeque

    java.lang.Object
      java.util.AbstractCollection
          edu.emory.mathcs.backport.java.util.AbstractCollection
              edu.emory.mathcs.backport.java.util.ArrayDeque

All Implemented Interfaces:
  java.lang.Cloneable, java.util.Collection, Deque, Queue, java.io.Serializable

public class ArrayDeque
extends AbstractCollection
implements Deque, java.lang.Cloneable, java.io.Serializable

Resizable-array implementation of the `Deque` interface. Array deques have no capacity restrictions; they grow as necessary to support usage. They are not thread-safe; in the absence of external synchronization, they do not support concurrent access by multiple threads. Null elements are prohibited. This class is likely to be faster than `Stack` when used as a stack, and faster than `LinkedList` when used as a queue.

Most `ArrayDeque` operations run in amortized constant time. Exceptions include `remove`, `removeFirstOccurrence`, `removeLastOccurrence`, `contains`, `iterator.remove()`, and the bulk operations, all of which run in linear time.

The iterators returned by this class's `iterator` method are fail-fast: If the deque is modified at any time after the iterator is created, in any way except through the iterator's own `remove` method, the iterator will generally throw a `ConcurrentModificationException`. Thus, in the face of concurrent modification, the iterator fails quickly and cleanly, rather than risking arbitrary, non-deterministic behavior at an undetermined time in the future.

Note that the fail-fast behavior of an iterator cannot be guaranteed as it is, generally speaking, impossible to make any hard guarantees in the presence of unsynchronized concurrent modification. Fail-fast iterators throw `ConcurrentModificationException` on a best-effort basis. Therefore, it would be wrong to write a program that depended on this exception for its correctness: the fail-fast behavior of iterators should be used only to detect bugs.

This class and its iterator implement all of the optional methods of the `Collection` and `Iterator` interfaces.

This class is a member of the Java Collections Framework.

Since:
  1.6
Author:
  Josh Bloch and Doug Lea
See Also:
  Serialized Form

Constructor Summary
`ArrayDeque()` Constructs an empty array deque with an initial capacity sufficient to hold 16 elements.
`ArrayDeque(java.util.Collection c)` Constructs a deque containing the elements of the specified collection, in the order they are returned by the collection's iterator.
`ArrayDeque(int numElements)` Constructs an empty array deque with an initial capacity sufficient to hold the specified number of elements.

Method Summary
`boolean` | `add(java.lang.Object e)` Inserts the specified element at the end of this deque.
`void` | `addFirst(java.lang.Object e)` Inserts the specified element at the front of this deque.
`void` | `addLast(java.lang.Object e)` Inserts the specified element at the end of this deque.
`void` | `clear()` Removes all of the elements from this deque.
`java.lang.Object` | `clone()` Returns a copy of this deque.
`boolean` | `contains(java.lang.Object o)` Returns `true` if this deque contains the specified element.
`java.util.Iterator` | `descendingIterator()` Returns an iterator over the elements in this deque in reverse sequential order.
`java.lang.Object` | `element()` Retrieves, but does not remove, the head of the queue represented by this deque.
`java.lang.Object` | `getFirst()` Retrieves, but does not remove, the first element of this deque.
`java.lang.Object` | `getLast()` Retrieves, but does not remove, the last element of this deque.
`boolean` | `isEmpty()` Returns `true` if this deque contains no elements.
`java.util.Iterator` | `iterator()` Returns an iterator over the elements in this deque.
`boolean` | `offer(java.lang.Object e)` Inserts the specified element at the end of this deque.
`boolean` | `offerFirst(java.lang.Object e)` Inserts the specified element at the front of this deque.
`boolean` | `offerLast(java.lang.Object e)` Inserts the specified element at the end of this deque.
`java.lang.Object` | `peek()` Retrieves, but does not remove, the head of the queue represented by this deque, or returns `null` if this deque is empty.
`java.lang.Object` | `peekFirst()` Retrieves, but does not remove, the first element of this deque, or returns `null` if this deque is empty.
`java.lang.Object` | `peekLast()` Retrieves, but does not remove, the last element of this deque, or returns `null` if this deque is empty.
`java.lang.Object` | `poll()` Retrieves and removes the head of the queue represented by this deque (in other words, the first element of this deque), or returns `null` if this deque is empty.
`java.lang.Object` | `pollFirst()` Retrieves and removes the first element of this deque, or returns `null` if this deque is empty.
`java.lang.Object` | `pollLast()` Retrieves and removes the last element of this deque, or returns `null` if this deque is empty.
`java.lang.Object` | `pop()` Pops an element from the stack represented by this deque.
`void` | `push(java.lang.Object e)` Pushes an element onto the stack represented by this deque.
`java.lang.Object` | `remove()` Retrieves and removes the head of the queue represented by this deque.
`boolean` | `remove(java.lang.Object o)` Removes a single instance of the specified element from this deque.
`java.lang.Object` | `removeFirst()` Retrieves and removes the first element of this deque.
`boolean` | `removeFirstOccurrence(java.lang.Object o)` Removes the first occurrence of the specified element in this deque (when traversing the deque from head to tail).
`java.lang.Object` | `removeLast()` Retrieves and removes the last element of this deque.
`boolean` | `removeLastOccurrence(java.lang.Object o)` Removes the last occurrence of the specified element in this deque (when traversing the deque from head to tail).
`int` | `size()` Returns the number of elements in this deque.
`java.lang.Object[]` | `toArray()` Returns an array containing all of the elements in this deque in proper sequence (from first to last element).
`java.lang.Object[]` | `toArray(java.lang.Object[] a)` Returns an array containing all of the elements in this deque in proper sequence (from first to last element); the runtime type of the returned array is that of the specified array.

Methods inherited from class java.util.AbstractCollection
`addAll, containsAll, removeAll, retainAll, toString`

Methods inherited from class java.lang.Object
`equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Methods inherited from interface java.util.Collection
`addAll, containsAll, equals, hashCode, removeAll, retainAll`

Constructor Detail

### ArrayDeque

    public ArrayDeque()

  Constructs an empty array deque with an initial capacity sufficient to hold 16 elements.

### ArrayDeque

    public ArrayDeque(int numElements)

  Constructs an empty array deque with an initial capacity sufficient to hold the specified number of elements.

Parameters:
  `numElements` - lower bound on initial capacity of the deque

### ArrayDeque

    public ArrayDeque(java.util.Collection c)

  Constructs a deque containing the elements of the specified collection, in the order they are returned by the collection's iterator. (The first element returned by the collection's iterator becomes the first element, or front of the deque.)

Parameters:
  `c` - the collection whose elements are to be placed into the deque
Throws:
  `java.lang.NullPointerException` - if the specified collection is null

Method Detail

### addFirst

    public void addFirst(java.lang.Object e)

  Inserts the specified element at the front of this deque.

  Specified by:
    `addFirst` in interface `Deque`
  Parameters:
    `e` - the element to add
  Throws:
    `java.lang.NullPointerException` - if the specified element is null

### addLast

    public void addLast(java.lang.Object e)

  Inserts the specified element at the end of this deque.

  This method is equivalent to `add(java.lang.Object)`.

  Specified by:
    `addLast` in interface `Deque`
  Parameters:
    `e` - the element to add
  Throws:
    `java.lang.NullPointerException` - if the specified element is null

### offerFirst

    public boolean offerFirst(java.lang.Object e)

  Inserts the specified element at the front of this deque.

  Specified by:
    `offerFirst` in interface `Deque`
  Parameters:
    `e` - the element to add
  Returns:
    `true` (as specified by `Deque.offerFirst(java.lang.Object)`)
  Throws:
    `java.lang.NullPointerException` - if the specified element is null

### offerLast

    public boolean offerLast(java.lang.Object e)

  Inserts the specified element at the end of this deque.

  Specified by:
    `offerLast` in interface `Deque`
  Parameters:
    `e` - the element to add
  Returns:
    `true` (as specified by `Deque.offerLast(java.lang.Object)`)
  Throws:
    `java.lang.NullPointerException` - if the specified element is null

### removeFirst

    public java.lang.Object removeFirst()

  Description copied from interface: `Deque`
  Retrieves and removes the first element of this deque. This method differs from `pollFirst` only in that it throws an exception if this deque is empty.

  Specified by:
    `removeFirst` in interface `Deque`
  Returns:
    the head of this deque
  Throws:
    `java.util.NoSuchElementException`

### removeLast

    public java.lang.Object removeLast()

  Description copied from interface: `Deque`
  Retrieves and removes the last element of this deque. This method differs from `pollLast` only in that it throws an exception if this deque is empty.

  Specified by:
    `removeLast` in interface `Deque`
  Returns:
    the tail of this deque
  Throws:
    `java.util.NoSuchElementException`

### pollFirst

    public java.lang.Object pollFirst()

  Description copied from interface: `Deque`
  Retrieves and removes the first element of this deque, or returns `null` if this deque is empty.

  Specified by:
    `pollFirst` in interface `Deque`
  Returns:
    the head of this deque, or `null` if this deque is empty

### pollLast

    public java.lang.Object pollLast()

  Description copied from interface: `Deque`
  Retrieves and removes the last element of this deque, or returns `null` if this deque is empty.

  Specified by:
    `pollLast` in interface `Deque`
  Returns:
    the tail of this deque, or `null` if this deque is empty

### getFirst

    public java.lang.Object getFirst()

  Description copied from interface: `Deque`
  Retrieves, but does not remove, the first element of this deque. This method differs from `peekFirst` only in that it throws an exception if this deque is empty.

  Specified by:
    `getFirst` in interface `Deque`
  Returns:
    the head of this deque
  Throws:
    `java.util.NoSuchElementException`

### getLast

    public java.lang.Object getLast()

  Description copied from interface: `Deque`
  Retrieves, but does not remove, the last element of this deque. This method differs from `peekLast` only in that it throws an exception if this deque is empty.

  Specified by:
    `getLast` in interface `Deque`
  Returns:
    the tail of this deque
  Throws:
    `java.util.NoSuchElementException`

### peekFirst

    public java.lang.Object peekFirst()

  Description copied from interface: `Deque`
  Retrieves, but does not remove, the first element of this deque, or returns `null` if this deque is empty.

  Specified by:
    `peekFirst` in interface `Deque`
  Returns:
    the head of this deque, or `null` if this deque is empty

### peekLast

    public java.lang.Object peekLast()

  Description copied from interface: `Deque`
  Retrieves, but does not remove, the last element of this deque, or returns `null` if this deque is empty.

  Specified by:
    `peekLast` in interface `Deque`
  Returns:
    the tail of this deque, or `null` if this deque is empty

### removeFirstOccurrence

    public boolean removeFirstOccurrence(java.lang.Object o)

  Removes the first occurrence of the specified element in this deque (when traversing the deque from head to tail). If the deque does not contain the element, it is unchanged. More formally, removes the first element `e` such that `o.equals(e)` (if such an element exists). Returns `true` if this deque contained the specified element (or equivalently, if this deque changed as a result of the call).

  Specified by:
    `removeFirstOccurrence` in interface `Deque`
  Parameters:
    `o` - element to be removed from this deque, if present
  Returns:
    `true` if the deque contained the specified element

### removeLastOccurrence

    public boolean removeLastOccurrence(java.lang.Object o)

  Removes the last occurrence of the specified element in this deque (when traversing the deque from head to tail). If the deque does not contain the element, it is unchanged. More formally, removes the last element `e` such that `o.equals(e)` (if such an element exists). Returns `true` if this deque contained the specified element (or equivalently, if this deque changed as a result of the call).

  Specified by:
    `removeLastOccurrence` in interface `Deque`
  Parameters:
    `o` - element to be removed from this deque, if present
  Returns:
    `true` if the deque contained the specified element

### add

    public boolean add(java.lang.Object e)

  Inserts the specified element at the end of this deque.

  This method is equivalent to `addLast(java.lang.Object)`.

  Specified by:
    `add` in interface `Deque`
  Parameters:
    `e` - the element to add
  Returns:
    `true` (as specified by `Collection.add(java.lang.Object)`)
  Throws:
    `java.lang.NullPointerException` - if the specified element is null

### offer

    public boolean offer(java.lang.Object e)

  Inserts the specified element at the end of this deque.

  This method is equivalent to `offerLast(java.lang.Object)`.

  Specified by:
    `offer` in interface `Deque`
  Parameters:
    `e` - the element to add
  Returns:
    `true` (as specified by `Queue.offer(java.lang.Object)`)
  Throws:
    `java.lang.NullPointerException` - if the specified element is null

### remove

    public java.lang.Object remove()

  Retrieves and removes the head of the queue represented by this deque. This method differs from `poll` only in that it throws an exception if this deque is empty.

  This method is equivalent to `removeFirst()`.

  Specified by:
    `remove` in interface `Deque`
  Returns:
    the head of the queue represented by this deque
  Throws:
    `java.util.NoSuchElementException`

### poll

    public java.lang.Object poll()

  Retrieves and removes the head of the queue represented by this deque (in other words, the first element of this deque), or returns `null` if this deque is empty.

  This method is equivalent to `pollFirst()`.

  Specified by:
    `poll` in interface `Deque`
  Returns:
    the head of the queue represented by this deque, or `null` if this deque is empty

### element

    public java.lang.Object element()

  Retrieves, but does not remove, the head of the queue represented by this deque. This method differs from `peek` only in that it throws an exception if this deque is empty.

  This method is equivalent to `getFirst()`.

  Specified by:
    `element` in interface `Deque`
  Returns:
    the head of the queue represented by this deque
  Throws:
    `java.util.NoSuchElementException`

### peek

    public java.lang.Object peek()

  Retrieves, but does not remove, the head of the queue represented by this deque, or returns `null` if this deque is empty.

  This method is equivalent to `peekFirst()`.

  Specified by:
    `peek` in interface `Deque`
  Returns:
    the head of the queue represented by this deque, or `null` if this deque is empty

### push

    public void push(java.lang.Object e)

  Pushes an element onto the stack represented by this deque. In other words, inserts the element at the front of this deque.

  This method is equivalent to `addFirst(java.lang.Object)`.

  Specified by:
    `push` in interface `Deque`
  Parameters:
    `e` - the element to push
  Throws:
    `java.lang.NullPointerException` - if the specified element is null

### pop

    public java.lang.Object pop()

  Pops an element from the stack represented by this deque. In other words, removes and returns the first element of this deque.

  This method is equivalent to `removeFirst()`.

  Specified by:
    `pop` in interface `Deque`
  Returns:
    the element at the front of this deque (which is the top of the stack represented by this deque)
  Throws:
    `java.util.NoSuchElementException`

### size

    public int size()

  Returns the number of elements in this deque.

  Specified by:
    `size` in interface `Deque`
  Returns:
    the number of elements in this deque

### isEmpty

    public boolean isEmpty()

  Returns `true` if this deque contains no elements.

  Specified by:
    `isEmpty` in interface `java.util.Collection`
  Returns:
    `true` if this deque contains no elements

### iterator

    public java.util.Iterator iterator()

  Returns an iterator over the elements in this deque. The elements will be ordered from first (head) to last (tail). This is the same order that elements would be dequeued (via successive calls to `remove()` or popped (via successive calls to `pop()`).

  Specified by:
    `iterator` in interface `Deque`
  Returns:
    an iterator over the elements in this deque

### descendingIterator

    public java.util.Iterator descendingIterator()

  Description copied from interface: `Deque`
  Returns an iterator over the elements in this deque in reverse sequential order. The elements will be returned in order from last (tail) to first (head).

  Specified by:
    `descendingIterator` in interface `Deque`
  Returns:
    an iterator over the elements in this deque in reverse sequence

### contains

    public boolean contains(java.lang.Object o)

  Returns `true` if this deque contains the specified element. More formally, returns `true` if and only if this deque contains at least one element `e` such that `o.equals(e)`.

  Specified by:
    `contains` in interface `Deque`
  Parameters:
    `o` - object to be checked for containment in this deque
  Returns:
    `true` if this deque contains the specified element

### remove

    public boolean remove(java.lang.Object o)

  Removes a single instance of the specified element from this deque. If the deque does not contain the element, it is unchanged. More formally, removes the first element `e` such that `o.equals(e)` (if such an element exists). Returns `true` if this deque contained the specified element (or equivalently, if this deque changed as a result of the call).

  This method is equivalent to `removeFirstOccurrence(java.lang.Object)`.

  Specified by:
    `remove` in interface `Deque`
  Parameters:
    `o` - element to be removed from this deque, if present
  Returns:
    `true` if this deque contained the specified element

### clear

    public void clear()

  Removes all of the elements from this deque. The deque will be empty after this call returns.

  Specified by:
    `clear` in interface `java.util.Collection`

### toArray

    public java.lang.Object[] toArray()

  Returns an array containing all of the elements in this deque in proper sequence (from first to last element).

  The returned array will be "safe" in that no references to it are maintained by this deque. (In other words, this method must allocate a new array). The caller is thus free to modify the returned array.

  This method acts as bridge between array-based and collection-based APIs.

  Specified by:
    `toArray` in interface `java.util.Collection`
  Overrides:
    `toArray` in class `AbstractCollection`
  Returns:
    an array containing all of the elements in this deque

### toArray

    public java.lang.Object[] toArray(java.lang.Object[] a)

  Returns an array containing all of the elements in this deque in proper sequence (from first to last element); the runtime type of the returned array is that of the specified array. If the deque fits in the specified array, it is returned therein. Otherwise, a new array is allocated with the runtime type of the specified array and the size of this deque.

  If this deque fits in the specified array with room to spare (i.e., the array has more elements than this deque), the element in the array immediately following the end of the deque is set to `null`.

  Like the `toArray()` method, this method acts as bridge between array-based and collection-based APIs. Further, this method allows precise control over the runtime type of the output array, and may, under certain circumstances, be used to save allocation costs.

  Suppose `x` is a deque known to contain only strings. The following code can be used to dump the deque into a newly allocated array of `String`:

           String[] y = x.toArray(new String[0]);

  Note that `toArray(new Object[0])` is identical in function to `toArray()`.

  Specified by:
    `toArray` in interface `java.util.Collection`
  Overrides:
    `toArray` in class `AbstractCollection`
  Parameters:
    `a` - the array into which the elements of the deque are to be stored, if it is big enough; otherwise, a new array of the same runtime type is allocated for this purpose
  Returns:
    an array containing all of the elements in this deque
  Throws:
    `java.lang.ArrayStoreException` - if the runtime type of the specified array is not a supertype of the runtime type of every element in this deque
    `java.lang.NullPointerException` - if the specified array is null

### clone

    public java.lang.Object clone()

  Returns a copy of this deque.

  Returns:
    a copy of this deque

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD